ogr2ogr(1)

NAME
ogr2ogr - ogr2ogr converts simple features data between file formats

SYNOPSIS

Usage: ogr2ogr [--help-general] [-skipfailures] [-append] [-update]
               [-select field_list] [-where restricted_where]
               [-progress] [-sql <sql statement>] [-dialect dialect]
               [-preserve_fid] [-fid FID]
               [-spat xmin ymin xmax ymax] [-geomfield field]
               [-a_srs srs_def] [-t_srs srs_def] [-s_srs srs_def]
               [-f format_name] [-overwrite] [[-dsco NAME=VALUE] ...]
               dst_datasource_name src_datasource_name
               [-lco NAME=VALUE] [-nln name] [-nlt type] [-dim 2|3|layer_dim] [layer [layer ...]]
Advanced options :
               [-gt n]
               [-clipsrc [xmin ymin xmax ymax]|WKT|datasource|spat_extent]
               [-clipsrcsql sql_statement] [-clipsrclayer layer]
               [-clipsrcwhere expression]
               [-clipdst [xmin ymin xmax ymax]|WKT|datasource]
               [-clipdstsql sql_statement] [-clipdstlayer layer]
               [-clipdstwhere expression]
               [-wrapdateline] [-datelineoffset val]
               [[-simplify tolerance] | [-segmentize max_dist]]
               [-addfields]
               [-fieldTypeToString All|(type1[,type2]*)] [-unsetFieldWidth]
               [-fieldmap identity | index1[,index2]*]
               [-splitlistfields] [-maxsubfields val]
               [-explodecollections] [-zfield field_name]
               [-gcp pixel line easting northing [elevation]]* [-order n | -tps].fi

DESCRIPTION

This program can be used to convert simple features data between file formats performing various operations during the process such as spatial or attribute selections, reducing the set of attributes, setting the output coordinate system or even reprojecting the features during translation.

-f format_name:
    output file format name (default is ESRI Shapefile), some possible values are:

     -f "ESRI Shapefile"
     -f "TIGER"
     -f "MapInfo File"
     -f "GML"
     -f "PostgreSQL"

-append:
    Append to existing layer instead of creating new

-overwrite:
    Delete the output layer and recreate it empty

-update:
    Open existing output datasource in update mode rather than trying to create a new one

-select field_list:
    Comma-delimited list of fields from input layer to copy to the new layer. A field is skipped if mentioned previously in the list even if the input layer has duplicate field names. (Defaults to all; any field is skipped if a subsequent field with same name is found.) Starting with OGR 1.11, geometry fields can also be specified in the list.

-progress:
    (starting with GDAL 1.7.0) Display progress on terminal. Only works if input layers have the 'fast feature count' capability.

-sql sql_statement:
    SQL statement to execute. The resulting table/layer will be saved to the output.

-dialect dialect:
    SQL dialect. In some cases can be used to use (unoptimized) OGR SQL instead of the native SQL of an RDBMS by passing OGRSQL. Starting with GDAL 1.10, the 'SQLITE' dialect can also be used with any datasource.

-where restricted_where:
    Attribute query (like SQL WHERE)

-skipfailures:
    Continue after a failure, skipping the failed feature.

-spat xmin ymin xmax ymax:
    spatial query extents. Only features whose geometry intersects the extents will be selected. The geometries will not be clipped unless -clipsrc is specified

-geomfield field:
    (OGR >= 1.11) Name of the geometry field on which the spatial filter operates on.

-dsco NAME=VALUE:
    Dataset creation option (format specific)

-lco NAME=VALUE:
    Layer creation option (format specific)

-nln name:
    Assign an alternate name to the new layer

-nlt type:
    Define the geometry type for the created layer. One of NONE, GEOMETRY, POINT, LINESTRING, POLYGON, GEOMETRYCOLLECTION, MULTIPOINT, MULTIPOLYGON or MULTILINESTRING. Add '25D' to the name to get 2.5D versions. Starting with GDAL 1.10, PROMOTE_TO_MULTI can be used to automatically promote layers that mix polygon or multipolygons to multipolygons, and layers that mix linestrings or multilinestrings to multilinestrings. Can be usefull when converting shapefiles to PostGIS (and other target drivers) that implements strict checks for geometry type.

-dim val:
    (starting with GDAL 1.10) Force the coordinate dimension to val (valid values are 2 or 3). This affects both the layer geometry type, and feature geometries. Starting with GDAL 1.11, the value can be set to 'layer_dim' to instruct feature geometries to be promoted to the coordinate dimension declared by the layer.

-a_srs srs_def:
    Assign an output SRS

-t_srs srs_def:
    Reproject/transform to this SRS on output

-s_srs srs_def:
    Override source SRS

-preserve_fid:
    Use the FID of the source features instead of letting the output driver to automatically assign a new one.

-fid fid:
    If provided, only the feature with this feature id will be reported. Operates exclusive of the spatial or attribute queries. Note: if you want to select several features based on their feature id, you can also use the fact the 'fid' is a special field recognized by OGR SQL. So, '-where 'fid in (1,3,5)'' would select features 1, 3 and 5.

Srs_def can be a full WKT definition (hard to escape properly), or a well known definition (ie. EPSG:4326) or a file with a WKT definition.

Advanced options :

-gt n:
    group n features per transaction (default 20000 in OGR 1.11, 200 in previous releases). Increase the value for better performance when writing into DBMS drivers that have transaction support.

-clipsrc [xmin ymin xmax ymax]|WKT|datasource|spat_extent:
    (starting with GDAL 1.7.0) clip geometries to the specified bounding box (expressed in source SRS), WKT geometry (POLYGON or MULTIPOLYGON), from a datasource or to the spatial extent of the -spat option if you use the spat_extent keyword. When specifying a datasource, you will generally want to use it in combination of the -clipsrclayer, -clipsrcwhere or -clipsrcsql options

-clipsrcsql sql_statement:
    Select desired geometries using an SQL query instead.

-clipsrclayer layername:
    Select the named layer from the source clip datasource.

-clipsrcwhere expression:
    Restrict desired geometries based on attribute query.

-clipdst xmin ymin xmax ymax:
    (starting with GDAL 1.7.0) clip geometries after reprojection to the specified bounding box (expressed in dest SRS), WKT geometry (POLYGON or MULTIPOLYGON) or from a datasource. When specifying a datasource, you will generally want to use it in combination of the -clipdstlayer, -clipdstwhere or -clipdstsql options

-clipdstsql sql_statement:
    Select desired geometries using an SQL query instead.

-clipdstlayer layername:
    Select the named layer from the destination clip datasource.

-clipdstwhere expression:
    Restrict desired geometries based on attribute query.

-wrapdateline:
    (starting with GDAL 1.7.0) split geometries crossing the dateline meridian (long. = +/- 180deg)

-datelineoffset:
    (starting with GDAL 1.10) offset from dateline in degrees (default long. = +/- 10deg, geometries within 170deg to -170deg will be splited)

-simplify tolerance:
    (starting with GDAL 1.9.0) distance tolerance for simplification. Note: the algorithm used preserves topology per feature, in particular for polygon geometries, but not for a whole layer.

-segmentize max_dist:
    (starting with GDAL 1.6.0) maximum distance between 2 nodes. Used to create intermediate points

-fieldTypeToString type1, ...:
    (starting with GDAL 1.7.0) converts any field of the specified type to a field of type string in the destination layer. Valid types are : Integer, Real, String, Date, Time, DateTime, Binary, IntegerList, RealList, StringList. Special value All can be used to convert all fields to strings. This is an alternate way to using the CAST operator of OGR SQL, that may avoid typing a long SQL query.

-unsetFieldWidth:
    (starting with GDAL 1.11) set field width and precision to 0.

-splitlistfields:
    (starting with GDAL 1.8.0) split fields of type StringList, RealList or IntegerList into as many fields of type String, Real or Integer as necessary.

-maxsubfields val:
    To be combined with -splitlistfields to limit the number of subfields created for each split field.

-explodecollections:
    (starting with GDAL 1.8.0) produce one feature for each geometry in any kind of geometry collection in the source file

-zfield field_name:
    (starting with GDAL 1.8.0) Uses the specified field to fill the Z coordinate of geometries

-gcp ungeoref_x ungeoref_y georef_x georef_y elevation:
    (starting with GDAL 1.10.0) Add the indicated ground control point. This option may be provided multiple times to provide a set of GCPs.

-order n:
    (starting with GDAL 1.10.0) order of polynomial used for warping (1 to 3). The default is to select a polynomial order based on the number of GCPs.

-tps:
    (starting with GDAL 1.10.0) Force use of thin plate spline transformer based on available GCPs.

-fieldmap:
    (starting with GDAL 1.10.0) Specifies the list of field indexes to be copied from the source to the destination. The (n)th value specified in the list is the index of the field in the target layer definition in which the n(th) field of the source layer must be copied. Index count starts at zero. There must be exactly as many values in the list as the count of the fields in the source layer. We can use the 'identity' setting to specify that the fields should be transferred by using the same order. This setting should be used along with the -append setting.

-addfields:
    (starting with GDAL 1.11) This is a specialized version of -append. Contrary to -append, -addfields has the effect of adding, to existing target layers, the new fields found in source layers. This option is usefull when merging files that have non-strictly identical structures. This might not work for output formats that don't support adding fields to existing non-empty layers.

PERFORMANCE HINTS

When writing into transactional DBMS (SQLite/PostgreSQL,MySQL, etc...), it might be beneficial to increase the number of INSERT statements executed between BEGIN TRANSACTION and COMMIT TRANSACTION statements. This number is specified with the -gt option. For example, for SQLite, explicitly defining -gt 65536 ensures optimal performance while populating some table containing many hundredth thousand or million rows. However, note that if there are failed insertions, the scope of -skipfailures is a whole transaction.

For PostgreSQL, the PG_USE_COPY config option can be set to YES for significantly insertion performance boot. See the PG driver documentation page.

More generally, consult the documentation page of the input and output drivers for performance hints.

EXAMPLE

Example appending to an existing layer (both flags need to be used):

% ogr2ogr -update -append -f PostgreSQL PG:dbname=warmerda abc.tab

Example reprojecting from ETRS_1989_LAEA_52N_10E to EPSG:4326 and clipping to a bounding box

% ogr2ogr -wrapdateline -t_srs EPSG:4326 -clipdst -5 40 15 55 france_4326.shp europe_laea.shp

Example for using the -fieldmap setting. The first field of the source layer is used to fill the third field (index 2 = third field) of the target layer, the second field of the source layer is ignored, the third field of the source layer used to fill the fifth field of the target layer.

% ogr2ogr -append -fieldmap 2,-1,4 dst.shp src.shp

More examples are given in the individual format pages.

AUTHOR

Frank Warmerdam warmerdam@pobox.com, Silke Reimer silke@intevation.de